<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>Tuna User Guide</title><link rel="stylesheet" type="text/css" href="Common_Content/css/default.css" /><link rel="stylesheet" media="print" href="Common_Content/css/print.css" type="text/css" /><meta name="generator" content="publican 2.8" /><meta name="package" content="Red_Hat_Enterprise_MRG-Tuna_User_Guide-2-en-US-1-1" /><meta name="description" content="This book contains information on using the Tuna program to perform advanced tuning procedures for the MRG Realtime component of the Red Hat Enterprise MRG distributed computing platform. For more information on tuning, see the MRG Realtime Tuning Guide." /><script type="text/javascript" src="../../../../../toc.js"></script><script type="text/javascript">
              addID('Red_Hat_Enterprise_MRG');
              
	      addID('Red_Hat_Enterprise_MRG.2');
              
              addID('Red_Hat_Enterprise_MRG.2.books');
	      addID('Red_Hat_Enterprise_MRG.2.Tuna_User_Guide');
              </script></head><body class="toc_embeded "><div id="tocdiv" class="toc"><iframe id="tocframe" class="toc" src="../../../../toc.html">This is an iframe, to view it upgrade your browser or enable iframe display.</iframe></div><p id="title"><a class="left" href="http://www.redhat.com/mrg/"><img src="Common_Content/images/image_left.png" alt="Product Site" /></a><a class="right" href="http://www.redhat.com/docs/en-US/Red_Hat_Enterprise_MRG"><img src="Common_Content/images/image_right.png" alt="Documentation Site" /></a></p><div xml:lang="en-US" class="book" id="id4941836" lang="en-US"><div class="titlepage"><div><div class="producttitle"><span class="productname">Red Hat Enterprise MRG</span> <span class="productnumber">2</span></div><div><h1 id="id4941836" class="title">Tuna User Guide</h1></div><div><h2 class="subtitle">Using Tuna to perform advanced tuning procedures for the MRG Realtime component of the Red Hat Enterprise MRG distributed computing platform</h2></div><p class="edition">Edition 1</p><div><h3 class="corpauthor">
		<span class="inlinemediaobject"><object data="Common_Content/images/title_logo.svg" type="image/svg+xml"> </object></span>

	</h3></div><div><div xml:lang="en-US" class="authorgroup" lang="en-US"><div class="author"><h3 class="author"><span class="firstname">Lana</span> <span class="surname">Brindley</span></h3><div class="affiliation"><span class="orgname">Red Hat</span> <span class="orgdiv">Engineering Content Services</span></div><code class="email"><a class="email" href="mailto:lbrindle@redhat.com">lbrindle@redhat.com</a></code></div><div class="author"><h3 class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></h3><div class="affiliation"><span class="orgname">Red Hat</span> <span class="orgdiv">Engineering Content Services</span></div><code class="email"><a class="email" href="mailto:alyoung@redhat.com">alyoung@redhat.com</a></code></div></div></div><hr /><div><div id="id4351034" class="legalnotice"><h1 class="legalnotice">Legal Notice</h1><div class="para">
		Copyright <span class="trademark"></span>© 2011 Red Hat, Inc.
	</div><div class="para">
		The text of and illustrations in this document are licensed by Red Hat under a Creative Commons Attribution–Share Alike 3.0 Unported license ("CC-BY-SA"). An explanation of CC-BY-SA is available at <a href="http://creativecommons.org/licenses/by-sa/3.0/">http://creativecommons.org/licenses/by-sa/3.0/</a>. In accordance with CC-BY-SA, if you distribute this document or an adaptation of it, you must provide the URL for the original version.
	</div><div class="para">
		Red Hat, as the licensor of this document, waives the right to enforce, and agrees not to assert, Section 4d of CC-BY-SA to the fullest extent permitted by applicable law.
	</div><div class="para">
		Red Hat, Red Hat Enterprise Linux, the Shadowman logo, JBoss, MetaMatrix, Fedora, the Infinity Logo, and RHCE are trademarks of Red Hat, Inc., registered in the United States and other countries.
	</div><div class="para">
		<span class="trademark">Linux</span>® is the registered trademark of Linus Torvalds in the United States and other countries.
	</div><div class="para">
		<span class="trademark">Java</span>® is a registered trademark of Oracle and/or its affiliates.
	</div><div class="para">
		<span class="trademark">XFS</span>® is a trademark of Silicon Graphics International Corp. or its subsidiaries in the United States and/or other countries.
	</div><div class="para">
		<span class="trademark">MySQL</span>® is a registered trademark of MySQL AB in the United States, the European Union and other countries.
	</div><div class="para">
		All other trademarks are the property of their respective owners.
	</div><div class="para">
		
<div class="address"><p><br />
			<span class="street">1801 Varsity Drive</span><br />
			 <span class="city">Raleigh</span>, <span class="state">NC</span> <span class="postcode">27606-2072</span> <span class="country">USA</span><br />
			 <span class="phone">Phone: +1 919 754 3700</span><br />
			 <span class="phone">Phone: 888 733 4281</span><br />
			 <span class="fax">Fax: +1 919 754 3701</span><br />
<br />
</p></div>

	</div></div></div><div><div class="abstract"><h6>Abstract</h6><div class="para">
			This book contains information on using the Tuna program to perform advanced tuning procedures for the MRG Realtime component of the Red Hat Enterprise MRG distributed computing platform. For more information on tuning, see the <em class="citetitle">MRG Realtime Tuning Guide</em>.
		</div></div></div></div><hr /></div><div class="toc"><dl><dt><span class="preface"><a href="#pref-Tuna_User_Guide-Preface">Preface</a></span></dt><dd><dl><dt><span class="section"><a href="#id4170241">1. Document Conventions</a></span></dt><dd><dl><dt><span class="section"><a href="#id4386341">1.1. Typographic Conventions</a></span></dt><dt><span class="section"><a href="#id4457202">1.2. Pull-quote Conventions</a></span></dt><dt><span class="section"><a href="#id4384270">1.3. Notes and Warnings</a></span></dt></dl></dd><dt><span class="section"><a href="#sect_RedHat-Getting_Help_and_Giving_Feedback">2. Getting Help and Giving Feedback</a></span></dt><dd><dl><dt><span class="section"><a href="#sect_RedHat-Do_You_Need_Help">2.1. Do You Need Help?</a></span></dt><dt><span class="section"><a href="#sect-RedHat-We_Need_Feedback">2.2. We Need Feedback!</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#chap-Tuna_User_Guide-Installing_TUNA">1. Installing Tuna</a></span></dt><dt><span class="chapter"><a href="#chap-Tuna_User_Guide-Using_the_Graphical_User_Interface">2. Using the Graphical User Interface</a></span></dt><dd><dl><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Reviewing_the_System">2.1. Reviewing the System</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-CPU_Tuning">2.2. CPU Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-IRQ_Tuning">2.3. IRQ Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Task_Tuning">2.4. Task Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Examples_for_Using_TUNA_with_the_Graphical_User_Interface">2.5. Examples for Using Tuna with the Graphical User Interface</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Saving_Changes">2.6. Saving Changes</a></span></dt></dl></dd><dt><span class="chapter"><a href="#chap-Tuna_User_Guide-Using_the_Command_Line_Interface">3. Using the Command Line Interface</a></span></dt><dd><dl><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Reviewing_the_System">3.1. Reviewing the System</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-CPU_Tuning">3.2. CPU Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-IRQ_Tuning">3.3. IRQ Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Task_Tuning">3.4. Task Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Examples_for_Using_TUNA_with_the_Command_Line_Interface">3.5. Examples for Using Tuna with the Command Line Interface</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Saving_Changes">3.6. Saving Changes</a></span></dt></dl></dd><dt><span class="chapter"><a href="#chap-Tuna_User_Guide-Using_Testing_Tools_with_TUNA">4. Using Testing Tools with Tuna</a></span></dt><dd><dl><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_Testing_Tools_with_TUNA-Cyclictest">4.1. Cyclictest</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_Testing_Tools_with_TUNA-Oscilloscope">4.2. Oscilloscope</a></span></dt></dl></dd><dt><span class="chapter"><a href="#chap-Tuna_User_Guide-Frequently_Asked_Questions">5. Frequently Asked Questions</a></span></dt><dt><span class="chapter"><a href="#chap-Tuna_User_Guide-More_Information">6. More Information</a></span></dt><dd><dl><dt><span class="section"><a href="#sect-Tuna_User_Guide-More_Information-Reporting_Bugs">6.1. Reporting Bugs</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-More_Information-Further_Reading">6.2. Further Reading</a></span></dt></dl></dd><dt><span class="appendix"><a href="#appe-Tuna_User_Guide-Revision_History">A. Revision History</a></span></dt></dl></div><div xml:lang="en-US" class="preface" id="pref-Tuna_User_Guide-Preface" lang="en-US"><div class="titlepage"><div><div><h1 class="title">Preface</h1></div></div></div><div class="formalpara" id="form-Tuna_User_Guide-Preface-PRODUCT"><h5 class="formalpara">Red Hat Enterprise MRG</h5>
			This book contains basic installation and usage information for Tuna. Tuna was developed for tuning the MRG Realtime component of Red Hat Enterprise MRG, but can also be used to tune standard Red Hat Enterprise Linux systems. Red Hat Enterprise MRG is a high performance distributed computing platform consisting of three components:
		</div><div class="orderedlist"><ol><li class="listitem"><div class="para">
				<span class="emphasis"><em>M</em></span>essaging — Cross platform, high performance, reliable messaging using the Advanced Message Queuing Protocol (AMQP) standard.
			</div></li><li class="listitem"><div class="para">
				<span class="emphasis"><em>R</em></span>ealtime — Consistent low-latency and predictable response times for applications that require microsecond latency.
			</div></li><li class="listitem"><div class="para">
				<span class="emphasis"><em>G</em></span>rid — Distributed High Throughput (HTC) and High Performance Computing (HPC).
			</div></li></ol></div><div class="para">
		All three components of Red Hat Enterprise MRG are designed to be used as part of the platform, but can also be used separately.
	</div><div class="formalpara" id="form-Tuna_User_Guide-Preface-TUNA"><h5 class="formalpara">Tuna</h5>
			Tuna is a tool that can be used to adjust scheduler tunables such as scheduler policy, RT priority and CPU affinity. It also allows the user to see the results of these changes.
		</div><div class="para">
		Threads and IRQ handlers are able to be tuned. It is also possible to isolate CPU cores and sockets, moving all threads away from them so that a new, more important set of threads can run exclusively.
	</div><div class="para">
		Tuna provides a graphical user interface (GUI). The GUI displays the CPU topology on one screen, which helps identify problems. It also allows changes to made to running threads, and see the results of those changes immediately.
	</div><div class="para">
		Most Tuna operations can be performed on either the command line, or in the GUI.
	</div><div class="para">
		Performing tuning tasks using traditional Linux tools can be daunting and complicated. Tuna reduces that complexity and provides powerful tools for getting the most of the MRG Realtime system.
	</div><div class="para">
		For more information about MRG Realtime, see the <em class="citetitle">MRG Realtime Installation Guide</em>, <em class="citetitle">MRG Realtime Tuning Guide</em>, and the <em class="citetitle">MRG Realtime Reference Guide</em>.
	</div><div xml:lang="en-US" class="section" lang="en-US"><div class="titlepage"><div><div><h2 class="title" id="id4170241">1. Document Conventions</h2></div></div></div><div class="para">
		This manual uses several conventions to highlight certain words and phrases and draw attention to specific pieces of information.
	</div><div class="para">
		In PDF and paper editions, this manual uses typefaces drawn from the <a href="https://fedorahosted.org/liberation-fonts/">Liberation Fonts</a> set. The Liberation Fonts set is also used in HTML editions if the set is installed on your system. If not, alternative but equivalent typefaces are displayed. Note: Red Hat Enterprise Linux 5 and later includes the Liberation Fonts set by default.
	</div><div class="section"><div class="titlepage"><div><div><h3 class="title" id="id4386341">1.1. Typographic Conventions</h3></div></div></div><div class="para">
			Four typographic conventions are used to call attention to specific words and phrases. These conventions, and the circumstances they apply to, are as follows.
		</div><div class="para">
			<code class="literal">Mono-spaced Bold</code>
		</div><div class="para">
			Used to highlight system input, including shell commands, file names and paths. Also used to highlight keycaps and key combinations. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				To see the contents of the file <code class="filename">my_next_bestselling_novel</code> in your current working directory, enter the <code class="command">cat my_next_bestselling_novel</code> command at the shell prompt and press <span class="keycap"><strong>Enter</strong></span> to execute the command.
			</div></blockquote></div><div class="para">
			The above includes a file name, a shell command and a keycap, all presented in mono-spaced bold and all distinguishable thanks to context.
		</div><div class="para">
			Key combinations can be distinguished from keycaps by the hyphen connecting each part of a key combination. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				Press <span class="keycap"><strong>Enter</strong></span> to execute the command.
			</div><div class="para">
				Press <span class="keycap"><strong>Ctrl</strong></span>+<span class="keycap"><strong>Alt</strong></span>+<span class="keycap"><strong>F2</strong></span> to switch to the first virtual terminal. Press <span class="keycap"><strong>Ctrl</strong></span>+<span class="keycap"><strong>Alt</strong></span>+<span class="keycap"><strong>F1</strong></span> to return to your X-Windows session.
			</div></blockquote></div><div class="para">
			The first paragraph highlights the particular keycap to press. The second highlights two key combinations (each a set of three keycaps with each set pressed simultaneously).
		</div><div class="para">
			If source code is discussed, class names, methods, functions, variable names and returned values mentioned within a paragraph will be presented as above, in <code class="literal">mono-spaced bold</code>. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				File-related classes include <code class="classname">filesystem</code> for file systems, <code class="classname">file</code> for files, and <code class="classname">dir</code> for directories. Each class has its own associated set of permissions.
			</div></blockquote></div><div class="para">
			<span class="application"><strong>Proportional Bold</strong></span>
		</div><div class="para">
			This denotes words or phrases encountered on a system, including application names; dialog box text; labeled buttons; check-box and radio button labels; menu titles and sub-menu titles. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				Choose <span class="guimenu"><strong>System</strong></span> → <span class="guisubmenu"><strong>Preferences</strong></span> → <span class="guimenuitem"><strong>Mouse</strong></span> from the main menu bar to launch <span class="application"><strong>Mouse Preferences</strong></span>. In the <span class="guilabel"><strong>Buttons</strong></span> tab, click the <span class="guilabel"><strong>Left-handed mouse</strong></span> check box and click <span class="guibutton"><strong>Close</strong></span> to switch the primary mouse button from the left to the right (making the mouse suitable for use in the left hand).
			</div><div class="para">
				To insert a special character into a <span class="application"><strong>gedit</strong></span> file, choose <span class="guimenu"><strong>Applications</strong></span> → <span class="guisubmenu"><strong>Accessories</strong></span> → <span class="guimenuitem"><strong>Character Map</strong></span> from the main menu bar. Next, choose <span class="guimenu"><strong>Search</strong></span> → <span class="guimenuitem"><strong>Find…</strong></span> from the <span class="application"><strong>Character Map</strong></span> menu bar, type the name of the character in the <span class="guilabel"><strong>Search</strong></span> field and click <span class="guibutton"><strong>Next</strong></span>. The character you sought will be highlighted in the <span class="guilabel"><strong>Character Table</strong></span>. Double-click this highlighted character to place it in the <span class="guilabel"><strong>Text to copy</strong></span> field and then click the <span class="guibutton"><strong>Copy</strong></span> button. Now switch back to your document and choose <span class="guimenu"><strong>Edit</strong></span> → <span class="guimenuitem"><strong>Paste</strong></span> from the <span class="application"><strong>gedit</strong></span> menu bar.
			</div></blockquote></div><div class="para">
			The above text includes application names; system-wide menu names and items; application-specific menu names; and buttons and text found within a GUI interface, all presented in proportional bold and all distinguishable by context.
		</div><div class="para">
			<code class="command"><em class="replaceable"><code>Mono-spaced Bold Italic</code></em></code> or <span class="application"><strong><em class="replaceable"><code>Proportional Bold Italic</code></em></strong></span>
		</div><div class="para">
			Whether mono-spaced bold or proportional bold, the addition of italics indicates replaceable or variable text. Italics denotes text you do not input literally or displayed text that changes depending on circumstance. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				To connect to a remote machine using ssh, type <code class="command">ssh <em class="replaceable"><code>username</code></em>@<em class="replaceable"><code>domain.name</code></em></code> at a shell prompt. If the remote machine is <code class="filename">example.com</code> and your username on that machine is john, type <code class="command">ssh john@example.com</code>.
			</div><div class="para">
				The <code class="command">mount -o remount <em class="replaceable"><code>file-system</code></em></code> command remounts the named file system. For example, to remount the <code class="filename">/home</code> file system, the command is <code class="command">mount -o remount /home</code>.
			</div><div class="para">
				To see the version of a currently installed package, use the <code class="command">rpm -q <em class="replaceable"><code>package</code></em></code> command. It will return a result as follows: <code class="command"><em class="replaceable"><code>package-version-release</code></em></code>.
			</div></blockquote></div><div class="para">
			Note the words in bold italics above — username, domain.name, file-system, package, version and release. Each word is a placeholder, either for text you enter when issuing a command or for text displayed by the system.
		</div><div class="para">
			Aside from standard usage for presenting the title of a work, italics denotes the first use of a new and important term. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				Publican is a <em class="firstterm">DocBook</em> publishing system.
			</div></blockquote></div></div><div class="section"><div class="titlepage"><div><div><h3 class="title" id="id4457202">1.2. Pull-quote Conventions</h3></div></div></div><div class="para">
			Terminal output and source code listings are set off visually from the surrounding text.
		</div><div class="para">
			Output sent to a terminal is set in <code class="computeroutput">mono-spaced roman</code> and presented thus:
		</div><pre class="screen">books        Desktop   documentation  drafts  mss    photos   stuff  svn
books_tests  Desktop1  downloads      images  notes  scripts  svgs</pre><div class="para">
			Source-code listings are also set in <code class="computeroutput">mono-spaced roman</code> but add syntax highlighting as follows:
		</div><pre class="programlisting">package org.<span class="perl_Function">jboss</span>.<span class="perl_Function">book</span>.<span class="perl_Function">jca</span>.<span class="perl_Function">ex1</span>;

<span class="perl_Keyword">import</span> javax.naming.InitialContext;

<span class="perl_Keyword">public</span> <span class="perl_Keyword">class</span> ExClient
{
   <span class="perl_Keyword">public</span> <span class="perl_DataType">static</span> <span class="perl_DataType">void</span> <span class="perl_Function">main</span>(String args[]) 
       <span class="perl_Keyword">throws</span> Exception
   {
      InitialContext iniCtx = <span class="perl_Keyword">new</span> InitialContext();
      Object         ref    = iniCtx.<span class="perl_Function">lookup</span>(<span class="perl_String">"EchoBean"</span>);
      EchoHome       home   = (EchoHome) ref;
      Echo           echo   = home.<span class="perl_Function">create</span>();

      System.<span class="perl_Function">out</span>.<span class="perl_Function">println</span>(<span class="perl_String">"Created Echo"</span>);

      System.<span class="perl_Function">out</span>.<span class="perl_Function">println</span>(<span class="perl_String">"Echo.echo('Hello') = "</span> + echo.<span class="perl_Function">echo</span>(<span class="perl_String">"Hello"</span>));
   }
}</pre></div><div class="section"><div class="titlepage"><div><div><h3 class="title" id="id4384270">1.3. Notes and Warnings</h3></div></div></div><div class="para">
			Finally, we use three visual styles to draw attention to information that might otherwise be overlooked.
		</div><div class="note"><div class="admonition_header"><h2>Note</h2></div><div class="admonition"><div class="para">
				Notes are tips, shortcuts or alternative approaches to the task at hand. Ignoring a note should have no negative consequences, but you might miss out on a trick that makes your life easier.
			</div></div></div><div class="important"><div class="admonition_header"><h2>Important</h2></div><div class="admonition"><div class="para">
				Important boxes detail things that are easily missed: configuration changes that only apply to the current session, or services that need restarting before an update will apply. Ignoring a box labeled 'Important' will not cause data loss but may cause irritation and frustration.
			</div></div></div><div class="warning"><div class="admonition_header"><h2>Warning</h2></div><div class="admonition"><div class="para">
				Warnings should not be ignored. Ignoring warnings will most likely cause data loss.
			</div></div></div></div></div><div xml:lang="en-US" class="section" id="sect_RedHat-Getting_Help_and_Giving_Feedback" lang="en-US"><div class="titlepage"><div><div><h2 class="title" id="sect_RedHat-Getting_Help_and_Giving_Feedback">2. Getting Help and Giving Feedback</h2></div></div></div><div class="section" id="sect_RedHat-Do_You_Need_Help"><div class="titlepage"><div><div><h3 class="title" id="sect_RedHat-Do_You_Need_Help">2.1. Do You Need Help?</h3></div></div></div><a id="id4327927" class="indexterm"></a><div class="para">
			If you experience difficulty with a procedure described in this documentation, visit the Red Hat Customer Portal at <a href="http://access.redhat.com">http://access.redhat.com</a>. Through the customer portal, you can:
		</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
					search or browse through a knowledgebase of technical support articles about Red Hat products.
				</div></li><li class="listitem"><div class="para">
					submit a support case to Red Hat Global Support Services (GSS).
				</div></li><li class="listitem"><div class="para">
					access other product documentation.
				</div></li></ul></div><div class="para">
			Red Hat also hosts a large number of electronic mailing lists for discussion of Red Hat software and technology. You can find a list of publicly available mailing lists at <a href="https://www.redhat.com/mailman/listinfo">https://www.redhat.com/mailman/listinfo</a>. Click on the name of any mailing list to subscribe to that list or to access the list archives.
		</div></div><div class="section" id="sect-RedHat-We_Need_Feedback"><div class="titlepage"><div><div><h3 class="title" id="sect-RedHat-We_Need_Feedback">2.2. We Need Feedback!</h3></div></div></div><a id="id4286641" class="indexterm"></a><div class="para">
			If you find a typographical error in this manual, or if you have thought of a way to make this manual better, we would love to hear from you! Please submit a report in Bugzilla: <a href="http://bugzilla.redhat.com/">http://bugzilla.redhat.com/</a> against the product <span class="application"><strong>Red Hat Enterprise MRG.</strong></span>
		</div><div class="para">
			When submitting a bug report, be sure to mention the manual's identifier: <em class="citetitle">Tuna_User_Guide</em>
		</div><div class="para">
			If you have a suggestion for improving the documentation, try to be as specific as possible when describing it. If you have found an error, please include the section number and some of the surrounding text so we can find it easily.
		</div></div></div></div><div xml:lang="en-US" class="chapter" id="chap-Tuna_User_Guide-Installing_TUNA" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 1. Installing Tuna</h2></div></div></div><div class="para">
		Tuna is currently only available through the MRG Realtime channels on the <a href="https://rhn.redhat.com/help/about.pxt">Red Hat Network</a> (RHN).
	</div><div class="procedure" id="proc-Tuna_User_Guide-Installing_TUNA-Download_and_Install_TUNA"><h6>Procedure 1.1. Download and Install Tuna</h6><ol class="1"><li class="step"><div class="para">
				In order to install Tuna you will need to have registered your system with <a href="https://rhn.redhat.com/help/about.pxt">Red Hat Network</a>, and subscribe to one of the following channels:
			</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
						MRG Realtime v. 1 (for RHEL 5 Server 64-bit x86_64)
					</div></li><li class="listitem"><div class="para">
						MRG Realtime v. 1 (for RHEL 5 Server 32-bit i686)
					</div></li></ul></div></li><li class="step"><div class="para">
				Tuna requires the following packages:
			</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
						<code class="filename">python-linux-procfs</code>
					</div></li><li class="listitem"><div class="para">
						<code class="filename">python-schedutils</code>
					</div></li><li class="listitem"><div class="para">
						<code class="filename">python-ethtool</code>
					</div></li></ul></div><div class="para">
				In order to use the graphical user interface, the following packages are also required:
			</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
						<code class="filename">pygtk2</code>
					</div></li><li class="listitem"><div class="para">
						<code class="filename">pygtk2-libglade</code>
					</div></li></ul></div></li><li class="step"><div class="para">
				Once you have registered your system with Red Hat Network, and subscribed to the appropriate channel, Tuna can be installed using the <code class="command">yum</code> command. This will install all the necessary dependencies:
			</div><pre class="screen">
# yum install tuna
</pre></li><li class="step"><div class="para">
				Although Tuna can be run as an unprivileged user, not all processes will be available for configuration. For this reason, in most cases you will need to run Tuna as the root user:
			</div><pre class="screen">
# tuna
</pre><div class="para">
				With the appropriate privileges, Tuna could also be run with the <code class="command">sudo</code> command:
			</div><pre class="screen">
$ sudo tuna
</pre></li></ol></div><div class="note"><div class="admonition_header"><h2>Note</h2></div><div class="admonition"><div class="para">
			If you find that yum is not installing all the dependencies you require, make sure that you have registered your system with <a href="https://rhn.redhat.com/help/about.pxt">Red Hat Network</a>.
		</div></div></div></div><div xml:lang="en-US" class="chapter" id="chap-Tuna_User_Guide-Using_the_Graphical_User_Interface" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 2. Using the Graphical User Interface</h2></div></div></div><div class="toc"><dl><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Reviewing_the_System">2.1. Reviewing the System</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-CPU_Tuning">2.2. CPU Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-IRQ_Tuning">2.3. IRQ Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Task_Tuning">2.4. Task Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Examples_for_Using_TUNA_with_the_Graphical_User_Interface">2.5. Examples for Using Tuna with the Graphical User Interface</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Saving_Changes">2.6. Saving Changes</a></span></dt></dl></div><div class="para">
		Tuna can be used either from the command line interface, or the graphical interface. Both provide the same range of functionality. This chapter covers the graphical user interface.
	</div><div class="section" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Reviewing_the_System"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Reviewing_the_System">2.1. Reviewing the System</h2></div></div></div><div class="para">
			The main Tuna screen shows the current state of the system.
		</div><div class="mediaobject"><img src="images/Tuna_Main.png" width="444" alt="Tuna main window showing three sections" /></div><div class="procedure" id="proc-Tuna_User_Guide-Reviewing_the_System-Reviewing_the_System_in_the_GUI"><h6>Procedure 2.1. Reviewing the System in the GUI</h6><ol class="1"><li class="step"><div class="para">
					The main Tuna window is divided into three sections, for CPU, IRQ, and process information. The sections are divided by grab bars for adjustment. The window itself can also be resized.
				</div><div class="para">
					As values in each of the sections change, the entries are shown in bold.
				</div></li><li class="step"><div class="para">
					The CPU list shows all online CPUs and their current usage.
				</div><div class="para">
					The check-box beside the name of the CPU is used to filter the task list at the bottom of the window. Only tasks and IRQs that belong to checked CPUs will be displayed.
				</div><div class="mediaobject"><img src="images/Tuna_CPU.png" alt="Tuna CPU list" /></div></li><li class="step"><div class="para">
					The IRQ list shows all active interrupt requests (IRQs), their process ID (PID) and policy and priority information.
				</div><div class="mediaobject"><img src="images/Tuna_IRQ.png" width="444" alt="Tuna IRQ list" /></div></li><li class="step"><div class="para">
					The task list shows all running tasks.
				</div><div class="para">
					When a process is threaded, the task list shows the parent thread with all the children threads collapsed below it. Click on the arrow to the left of the process to expand the thread.
				</div><div class="para">
					The task list has a right-click menu. Select <span class="guimenuitem"><strong>Hide kernel threads</strong></span> to hide all kernel threads, and see only user threads. Click <span class="guimenuitem"><strong>Hide kernel threads</strong></span> again to restore the kernel threads. Similarly, <span class="guimenuitem"><strong>Hide user threads</strong></span> will hide all user threads and show only kernel threads. Clicking <span class="guimenuitem"><strong>Hide user threads</strong></span> again will restore the user threads.
				</div><div class="mediaobject"><img src="images/Tuna_Process.png" width="444" alt="Tuna Task list" /></div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-CPU_Tuning"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-CPU_Tuning">2.2. CPU Tuning</h2></div></div></div><div class="procedure" id="proc-Tuna_User_Guide-CPU_Tuning-CPU_Tuning_in_the_GUI"><h6>Procedure 2.2. CPU Tuning in the GUI</h6><ol class="1"><li class="step"><div class="para">
					To isolate a CPU, right click on the selected CPU, and select <span class="guimenuitem"><strong>Isolate CPU</strong></span> from the menu. This will cause all tasks currently running on that CPU to move to the next available CPU. This is achieved through removing the selected CPU from the current affinity mask of all threads, so that they no longer see that CPU as being available.
				</div></li><li class="step"><div class="para">
					To include a CPU, right click on the selected CPU, and select <span class="guimenuitem"><strong>Include CPU</strong></span> from the menu. This will allow tasks to run on that CPU.
				</div></li><li class="step"><div class="para">
					To restore a CPU, right click on the selected CPU, and select <span class="guimenuitem"><strong>Restore CPU</strong></span> from the menu. This will restore that CPU to its previous configuration.
				</div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-IRQ_Tuning"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-IRQ_Tuning">2.3. IRQ Tuning</h2></div></div></div><div class="procedure" id="proc-Tuna_User_Guide-IRQ_Tuning-IRQ_Tuning_in_the_GUI"><h6>Procedure 2.3. IRQ Tuning in the GUI</h6><ol class="1"><li class="step"><div class="para">
					Right click on an IRQ and select <span class="guibutton"><strong>Set IRQ Attributes</strong></span> to open the IRQ Attributes dialog box.
				</div><div class="mediaobject"><img src="images/Tuna_IRQ_Attribs_Dialog.png" width="444" alt="Tuna window showing the Set IRQ Attributes dialog box." /></div></li><li class="step"><div class="para">
					The IRQ Attributes dialog shows current information about the IRQ. It has three adjustable attributes:
				</div><div class="orderedlist"><ol><li class="listitem"><div class="para">
							Scheduling Policy
						</div><div class="para">
							A drop down list of the available policies.
						</div><div class="para">
							<code class="command">SCHED_OTHER</code> is the default policy. <code class="command">SCHED_FIFO</code> is a first in/first out realtime policy. A <code class="command">SCHED_FIFO</code> policy with a priority of <em class="parameter"><code>1</code></em> will always run ahead of <code class="command">SCHED_OTHER</code>. <code class="command">SCHED_RR</code> is a policy where threads of equal priority are treated in a round-robin fashion.
						</div></li><li class="listitem"><div class="para">
							Scheduler Priority
						</div><div class="para">
							A drop down list of the available priorities. This attribute will be disabled if the selected IRQ cannot have a set priority.
						</div><div class="para">
							Scheduler priorities range from 99 (highest) to 1 (lowest). Priorities can be set for threads that use the <code class="command">SCHED_FIFO</code> or <code class="command">SCHED_RR</code> policies.
						</div></li><li class="listitem"><div class="para">
							Affinity
						</div><div class="para">
							A numeric list of CPUs on which the IRQ can be run. This entry can be in the form of a comma-delimited list of CPU numbers, a range separated by a hyphen, or a combination of both. For example: <code class="command">0, 2-4, 7, 8</code>. This would instruct the IRQ to run on CPUs 0, 2, 3, 4, 7 and 8.
						</div><div class="para">
							This field will also accept hex masks. Hex masks must be preceded by <code class="command">Ox</code> in order to be recognized and interpreted correctly. Hex masks that do not use that format will be interpreted as a decimal CPU number.
						</div></li></ol></div></li></ol></div><div class="note"><div class="admonition_header"><h2>Note</h2></div><div class="admonition"><div class="para">
				See the <em class="citetitle">MRG Realtime Reference Guide</em> for more information on policy, priority, and affinity.
			</div></div></div><div class="note"><div class="admonition_header"><h2>Note</h2></div><div class="admonition"><div class="para">
				Moving IRQs and threads by specifying the CPUs they are to run on can be time consuming and difficult. Tuna also offers the ability to select threads and IRQs, and drag and drop them over the desired CPUs. This method can make changing the topology much easier.
			</div></div></div></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Task_Tuning"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Task_Tuning">2.4. Task Tuning</h2></div></div></div><div class="procedure" id="proc-Tuna_User_Guide-Task_Tuning-Task_Tuning_in_the_GUI"><h6>Procedure 2.4. Task Tuning in the GUI</h6><ol class="1"><li class="step"><div class="para">
					Right click on a task and select <span class="guibutton"><strong>Set Process Attributes</strong></span> to open the Process Attributes dialog box.
				</div><div class="mediaobject"><img src="images/Tuna_Process_Attribs_Dialog.png" width="444" alt="Tuna window showing the Set Process Attributes dialog box." /></div></li><li class="step"><div class="para">
					The Process Attributes dialog shows current information about the task. It allows you to set scheduling policy, scheduler priority, and CPU affinity for a task or set of tasks.
				</div><div class="orderedlist"><ol><li class="listitem"><div class="para">
							Thread Selection
						</div><div class="para">
							<span class="guibutton"><strong>Just the selected thread</strong></span> is selected by default. If the task has more than one thread, use <span class="guibutton"><strong>All threads of the selected process</strong></span> to make changes to all of the threads for that task. To use a regular expression (regex) to search for tasks, select <span class="guibutton"><strong>All command lines matching the regex below:</strong></span>. This will activate the <span class="guibutton"><strong>Command line regex:</strong></span> field and you can enter the regex. This field supports the <code class="command">*</code> and <code class="command">?</code> wildcards, and will match the entire command line. The task list will update to show only those tasks that match the regex.
						</div></li><li class="listitem"><div class="para">
							Policy, Priority and Affinity
						</div><div class="para">
							The <span class="guibutton"><strong>Policy</strong></span> drop down box contains the available scheduling policy options.
						</div><div class="para">
							The <span class="guibutton"><strong>Scheduler Priority</strong></span> drop down box contains the available priorities. This attribute will be disabled if the selected tasks cannot have a set priority.
						</div><div class="para">
							The <span class="guibutton"><strong>Affinity</strong></span> field contains a numeric list of CPUs on which the selected tasks can be run. This entry can be in the form of a comma-delimited list of CPU numbers, a range using square brackets, or a combination of both.
						</div></li><li class="listitem"><div class="para">
							Task List
						</div><div class="para">
							This shows a list of the the tasks currently being adjusted based on the thread and regex selections made.
						</div></li></ol></div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Examples_for_Using_TUNA_with_the_Graphical_User_Interface"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Examples_for_Using_TUNA_with_the_Graphical_User_Interface">2.5. Examples for Using Tuna with the Graphical User Interface</h2></div></div></div><div class="example" id="exam-Tuna_User_Guide-Examples_for_Using_TUNA_with_the_Graphical_User_Interface-Using_TUNA_with_the_Graphical_User_Interface"><h6>Example 2.1. Using Tuna with the Graphical User Interface</h6><div class="example-contents"><div class="para">
				This example uses a system with four or more processors. Two applications need to be run - <code class="command">Foo</code> and <code class="command">Bar</code>. The applications need to be run on dedicated processors - processor 0 for <code class="command">Foo</code> and processor 1 for <code class="command">Bar</code>.
			</div><div class="orderedlist"><ol><li class="listitem"><div class="para">
						Move everything off the chosen processors. Right-click on <code class="command">CPU 0</code> in the CPU list and select <span class="guibutton"><strong>Isolate CPU</strong></span> from the menu. Repeat for <code class="command">CPU 1</code>. The task list shows that no tasks are running on those processors.
					</div></li><li class="listitem"><div class="para">
						<code class="command">Foo</code> is a single task with several threads. The task and all its threads need to run on <code class="command">CPU 0</code>. Find <code class="command">Foo</code> in the process list, right-click on it and choose <span class="guibutton"><strong>Set process attributes</strong></span> from the menu. In the <span class="guibutton"><strong>Set Process Attributes</strong></span> dialog, select the radio button for <span class="guibutton"><strong>All threads of the selected process</strong></span>. In the <span class="guibutton"><strong>Affinity</strong></span> text box, change the text to <code class="command">0</code>. The scheduling policy and scheduler priority can also be adjusted if required. Click on <span class="guibutton"><strong>OK</strong></span> to save the changes and close the dialog box.
					</div></li><li class="listitem"><div class="para">
						<code class="command">Bar</code> is an application that has <code class="command">--none</code> as its first command line argument. Right-click anywhere in the task list and choose <span class="guibutton"><strong>Set process attributes</strong></span> from the menu. In the dialog, select the radio-button for <span class="guibutton"><strong>All command lines matching the regex below:</strong></span>. Type <code class="command">bar --none *</code> in the <span class="guibutton"><strong>Command line regex</strong></span> text box. The task list in the dialog box will update to include the matching processes and any associated threads. Change the <span class="guibutton"><strong>Affinity</strong></span> to <code class="command">0</code>. Make any changes for the scheduler and priority. Click on <span class="guibutton"><strong>OK</strong></span> to save your changes and close the dialog box.
					</div></li></ol></div></div></div><br class="example-break" /></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Saving_Changes"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Graphical_User_Interface-Saving_Changes">2.6. Saving Changes</h2></div></div></div><div class="procedure" id="proc-Tuna_User_Guide-Saving_Changes-Saving_Changes_in_the_GUI"><h6>Procedure 2.5. Saving Changes in the GUI</h6><ol class="1"><li class="step"><div class="para">
					Right-click in the Tuna graphical interface, and select the <span class="guimenuitem"><strong>Save kthreads tunings</strong></span> menu item.
				</div></li><li class="step"><div class="para">
					Tuna will prompt for a filename and directory. Enter a filename and select the location to save the file. Select <span class="guibutton"><strong>OK</strong></span> to continue.
				</div><div class="mediaobject"><img src="images/Tuna_Savekthreads.png" alt="Tuna window showing the Save kthreads tunings save dialog box" /></div></li></ol></div><div class="important"><div class="admonition_header"><h2>Important</h2></div><div class="admonition"><div class="para">
				This method will not save every option that is able to be changed with Tuna. This will save the kernel thread changes only. Any processes that are not currently running when they are changed will not be saved.
			</div></div></div></div></div><div xml:lang="en-US" class="chapter" id="chap-Tuna_User_Guide-Using_the_Command_Line_Interface" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 3. Using the Command Line Interface</h2></div></div></div><div class="toc"><dl><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Reviewing_the_System">3.1. Reviewing the System</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-CPU_Tuning">3.2. CPU Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-IRQ_Tuning">3.3. IRQ Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Task_Tuning">3.4. Task Tuning</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Examples_for_Using_TUNA_with_the_Command_Line_Interface">3.5. Examples for Using Tuna with the Command Line Interface</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Saving_Changes">3.6. Saving Changes</a></span></dt></dl></div><div class="para">
		Tuna can be used either from the command line interface, or the graphical interface. Both provide the same range of functionality. This chapter covers the command line interface.
	</div><div class="para">
		Use the <code class="command">--help</code> option to see all the available options: 
<pre class="screen">
# tuna --help
Usage: tuna [OPTIONS]
        -h, --help                               Give this help list
        -g, --gui                                Start the GUI
        -c, --cpus=CPU-LIST                      CPU-LIST affected by commands
        -C, --affect_children                    Operation will affect children threads
        -f, --filter                             Display filter the selected entities
        -i, --isolate                            Move all threads away from CPU-LIST
        -I, --include                            Allow all threads to run on CPU-LIST
        -K, --no_kthreads                        Operations will not affect kernel threads
        -m, --move                               Move selected entities to CPU-LIST
        -p, --priority=[POLICY]:RTPRIO           Set thread scheduler tunables: POLICY and RTPRIO
        -P, --show_threads                       Show thread list
        -Q, --show_irqs                          Show IRQ list
        -q, --irqs=IRQ-LIST                      IRQ-LIST affected by commands
        -s, --save=FILENAME                      Save kthreads sched tunables to FILENAME
        -S, --sockets=CPU-SOCKET-LIST            CPU-SOCKET-LIST affected by commands
        -t, --threads=THREAD-LIST                THREAD-LIST affected by commands
        -U, --no_uthreads                        Operations will not affect user threads
        -v, --version                            Show version
        -W, --what_is                            Provides help about selected entities
        -x, --spread                             Spread selected entities over CPU-LIST

</pre>

	</div><div class="para">
		When passing commands to Tuna using the command line, it is possible to pass multiple commands in one line and Tuna will process the commands sequentially: 
<pre class="screen">
tuna --socket 0 --isolate \
   --thread my_real_time_app --move \
   --irq serial --socket 1 --move \
   --irq eth* --socket 2 --spread \
   --show_threads --show_irqs
</pre>
		 The above command will distribute load across a four socket system. Commands such as this can be added to the initialization scripts of applications to serve as a configuration command.
	</div><div class="table" id="tabl-Tuna_User_Guide-Using_the_Command_Line_Interface-Tuna_Options"><h6>Table 3.1. Tuna Options</h6><div class="table-contents"><table summary="Tuna Options" border="1"><colgroup><col align="left" class="c1" width="50%" /><col align="left" class="c2" width="50%" /></colgroup><thead><tr><th colspan="2" align="center">
						Tuna Options
					</th></tr></thead><tbody><tr><td align="left">
						<code class="command">--help</code>
					</td><td align="left">
						Display the help list
					</td></tr><tr><td align="left">
						<code class="command">--gui</code>
					</td><td align="left">
						Start the graphical user interface
					</td></tr><tr><td align="left">
						<code class="command">--cpus=<em class="replaceable"><code>CPU-LIST</code></em></code>
					</td><td align="left">
						The CPUs to be controlled by Tuna. The list will remain in effect until a new list is specified
					</td></tr><tr><td align="left">
						<code class="command">--affect_children</code>
					</td><td align="left">
						Operation will affect children threads as well as the parent threads
					</td></tr><tr><td align="left">
						<code class="command">--filter</code>
					</td><td align="left">
						Filter the display to only show the affected entities
					</td></tr><tr><td align="left">
						<code class="command">--isolate <em class="replaceable"><code>CPU-LIST</code></em></code>
					</td><td align="left">
						Move all threads away from the specified CPUs
					</td></tr><tr><td align="left">
						<code class="command">--include <em class="replaceable"><code>CPU-LIST</code></em></code>
					</td><td align="left">
						Allow all threads to run on the specified CPUs
					</td></tr><tr><td align="left">
						<code class="command">--no_kthreads</code>
					</td><td align="left">
						Operation will not effect kernel threads
					</td></tr><tr><td align="left">
						<code class="command">--move</code>
					</td><td align="left">
						Move selected entities to the specified CPUs
					</td></tr><tr><td align="left">
						<code class="command">--priority=<em class="replaceable"><code>[POLICY]:RTPRIO</code></em></code>
					</td><td align="left">
						Set the thread to have the specified scheduler policy and priority
					</td></tr><tr><td align="left">
						<code class="command">--show_threads</code>
					</td><td align="left">
						Show the thread list
					</td></tr><tr><td align="left">
						<code class="command">--show_irqs</code>
					</td><td align="left">
						Show the IRQ list
					</td></tr><tr><td align="left">
						<code class="command">--irqs <em class="replaceable"><code>IRQ-LIST</code></em></code>
					</td><td align="left">
						Specify the list of IRQs that are to be affected by commands. The list will remain in effect until a new list is specified. IRQs can be added to the list by using <code class="command">+</code> and removed from the list by using <code class="command">-</code>
					</td></tr><tr><td align="left">
						<code class="command">--save <em class="replaceable"><code>FILENAME</code></em></code>
					</td><td align="left">
						Save the kernel threads schedules to a file called <em class="replaceable"><code>FILENAME</code></em>
					</td></tr><tr><td align="left">
						<code class="command">--sockets=<em class="replaceable"><code>CPU-SOCKET-LIST</code></em></code>
					</td><td align="left">
						The CPU sockets to be controlled by Tuna. This option takes into account the CPU topology, such as the cores that share a single processor cache, and that are on the same physical chip.
					</td></tr><tr><td align="left">
						<code class="command">--threads=<em class="replaceable"><code>THREAD-LIST</code></em></code>
					</td><td align="left">
						The threads to be controlled by Tuna. The list will remain in effect until a new list is specified. Threads can be added to the list by using <code class="command">+</code> and removed from the list by using <code class="command">-</code>
					</td></tr><tr><td align="left">
						<code class="command">--no_uthreads</code>
					</td><td align="left">
						Operation will not affect user threads
					</td></tr><tr><td align="left">
						<code class="command">--version</code>
					</td><td align="left">
						Show the current version of the Tuna package
					</td></tr><tr><td align="left">
						<code class="command">--what_is</code>
					</td><td align="left">
						To see further help on selected entities
					</td></tr><tr><td align="left">
						<code class="command">--spread</code>
					</td><td align="left">
						Spread the specified threads evenly between the selected CPUs
					</td></tr></tbody></table></div></div><br class="table-break" /><div class="section" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Reviewing_the_System"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Reviewing_the_System">3.1. Reviewing the System</h2></div></div></div><div class="para">
			Tuna can show what is happening currently on the system, before changes are made.
		</div><div class="procedure" id="proc-Tuna_User_Guide-Reviewing_the_System-Reviewing_the_System_in_the_CLI"><h6>Procedure 3.1. Reviewing the System in the CLI</h6><ol class="1"><li class="step"><div class="para">
					Use the <code class="command">--show_threads</code> command to view the current policies and priorities: 
<pre class="screen">
# tuna --show_threads
		  thread       
pid SCHED_ rtpri affinity             cmd
1      OTHER     0      0,1            init 
2       FIFO    99        0     migration/0 
3      OTHER     0        0     ksoftirqd/0 
4       FIFO    99        0      watchdog/0
</pre>

				</div></li><li class="step"><div class="para">
					Use the <code class="command">--show_irqs</code> command to view the current interrupts and their affinity: 
<pre class="screen">
# tuna --show_irqs
# users            affinity
0 timer                   0
1 i8042                   0
7 parport0                0
</pre>

				</div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-CPU_Tuning"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-CPU_Tuning">3.2. CPU Tuning</h2></div></div></div><div class="procedure" id="proc-Tuna_User_Guide-CPU_Tuning-CPU_Tuning_in_the_CLI"><h6>Procedure 3.2. CPU Tuning in the CLI</h6><div class="para">
				To tune CPUs on the command line in Tuna, first specify the list of CPUs to be affected, and then give the action to be performed.
			</div><ol class="1"><li class="step"><div class="para">
					Specify the list of CPUs to be affected by the command: 
<pre class="screen">
# tuna --cpus=<em class="replaceable"><code>CPU-LIST</code></em> --<em class="replaceable"><code>COMMAND</code></em></pre>

				</div></li><li class="step"><div class="para">
					To isolate a CPU: 
<pre class="screen">
# tuna --cpus=<em class="replaceable"><code>CPU-LIST</code></em> --isolate
</pre>
					 This command will cause all tasks currently running on that CPU to move to the next available CPU.
				</div></li><li class="step"><div class="para">
					To include a CPU: 
<pre class="screen">
# tuna --cpus=<em class="replaceable"><code>CPU-LIST</code></em> --include
</pre>
					 This command will allow threads to run on the specified CPU.
				</div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-IRQ_Tuning"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-IRQ_Tuning">3.3. IRQ Tuning</h2></div></div></div><div class="procedure" id="proc-Tuna_User_Guide-IRQ_Tuning-IRQ_Tuning_in_the_CLI"><h6>Procedure 3.3. IRQ Tuning in the CLI</h6><ol class="1"><li class="step"><div class="para">
					Specify the list of IRQs to be affected by the command: 
<pre class="screen">
# tuna --irqs=<em class="replaceable"><code>IRQ-LIST</code></em> --<em class="replaceable"><code>COMMAND</code></em></pre>

				</div></li><li class="step"><div class="para">
					To move an interrupt to a specified CPU: 
<pre class="screen">
# tuna --irqs=<em class="replaceable"><code>IRQ-LIST</code></em> --cpus=<em class="replaceable"><code>CPU</code></em> --move
</pre>

				</div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Task_Tuning"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Task_Tuning">3.4. Task Tuning</h2></div></div></div><div class="procedure" id="proc-Tuna_User_Guide-Task_Tuning-Task_Tuning_in_the_CLI"><h6>Procedure 3.4. Task Tuning in the CLI</h6><ol class="1"><li class="step"><div class="para">
					To change policy and priority information on threads, use the <code class="command">--priority=<em class="replaceable"><code>[POLICY]:RTPRIO</code></em></code> command, where <em class="replaceable"><code>POLICY</code></em> is the new policy and <em class="replaceable"><code>RTPRIO</code></em> is the new priority: 
<pre class="screen">
# tuna --threads 7861 --priority=RR:40
</pre>

				</div><div class="para">
					Policy can be either <code class="command">RR</code> for round-robin, <code class="command">FIFO</code> for first in/first out, or <code class="command">OTHER</code> for the default policy.
				</div><div class="para">
					Priority is a number between 1 (lowest priority) and 99 (highest priority).
				</div><div class="para">
					For more information on scheduler policy and priority, see the <em class="citetitle">MRG Realtime Reference Guide</em>.
				</div></li><li class="step"><div class="para">
					Use the <code class="command">--show_threads</code> command to check the changes: 
<pre class="screen">
# tuna --threads 7861 --show_threads

pid 	SCHED_ rtpri affinity voluntary nonvoluntary   cmd
7861     RR    40     0xff     33318        16957   IRQ-4 serial
</pre>

				</div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Examples_for_Using_TUNA_with_the_Command_Line_Interface"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Examples_for_Using_TUNA_with_the_Command_Line_Interface">3.5. Examples for Using Tuna with the Command Line Interface</h2></div></div></div><div class="example" id="exam-Tuna_User_Guide-Examples_for_Using_TUNA_with_the_Command_Line_Interface-Using_TUNA_with_the_Command_Line_Interface"><h6>Example 3.1. Using Tuna with the Command Line Interface</h6><div class="example-contents"><div class="para">
				This example uses a system with four or more processors. All <code class="command">ssh</code> threads need to run on CPUs 0 and 1. All <code class="command">http</code> threads need to run on CPUs 2 and 3.
			</div><pre class="screen">
# tuna --cpus=0,1 --threads ssh* --move --cpus 2,3 --threads http* --move
</pre><div class="para">
				This command will: 
				<div class="orderedlist"><ol><li class="listitem"><div class="para">
							Select CPUs 0 and 1
						</div></li><li class="listitem"><div class="para">
							Select all threads that begin with <code class="command">ssh</code>
						</div></li><li class="listitem"><div class="para">
							Move the selected threads to the selected CPUs. Tuna does this by setting the affinity mask of threads starting with <code class="command">ssh</code> to the appropriate CPUs. The CPUs can be expressed numerically as 0 and 1; hex mask as 0x3; binary as 11
						</div></li><li class="listitem"><div class="para">
							Reset the CPU list to 2 and 3
						</div></li><li class="listitem"><div class="para">
							Select all threads that begin with <code class="command">http</code>
						</div></li><li class="listitem"><div class="para">
							Move the selected threads to the selected CPUs. Tuna does this by setting the affinity mask of threads starting with <code class="command">http</code> to the appropriate CPUs. The CPUs can be expressed numerically as 2 and 3; hex mask as 0xC; binary as 1100
						</div></li></ol></div>

			</div></div></div><br class="example-break" /><div class="example" id="exam-Tuna_User_Guide-Examples_for_Using_TUNA_with_the_Command_Line_Interface-Using_the_show_threads_Command_to_View_the_Current_Configurations"><h6>Example 3.2. Using the <code class="command">show_threads</code> Command to View the Current Configurations</h6><div class="example-contents"><div class="para">
				This example uses the <code class="command">show_threads</code> command to display the current configuration, and test if the requested changes have worked as expected.
			</div><pre class="screen">
# tuna -t gnome-sc* -P -c0 -mP -c1 -mP -c+0 -mP
                       thread       ctxt_switches
     pid SCHED_ rtpri affinity voluntary nonvoluntary             cmd
   3861   OTHER     0      0,1     33997           58 gnome-screensav
                       thread       ctxt_switches
     pid SCHED_ rtpri affinity voluntary nonvoluntary             cmd
   3861   OTHER     0        0     33997           58 gnome-screensav
                       thread       ctxt_switches
     pid SCHED_ rtpri affinity voluntary nonvoluntary             cmd
   3861   OTHER     0        1     33997           58 gnome-screensav
                       thread       ctxt_switches
     pid SCHED_ rtpri affinity voluntary nonvoluntary             cmd
   3861   OTHER     0      0,1     33997           58 gnome-screensav 
</pre><div class="para">
				This command will: 
				<div class="orderedlist"><ol><li class="listitem"><div class="para">
							Select all threads that begin with <code class="command">gnome-sc</code>
						</div></li><li class="listitem"><div class="para">
							Show the selected threads, to check their affinity mask and RT priority
						</div></li><li class="listitem"><div class="para">
							Select CPU 0
						</div></li><li class="listitem"><div class="para">
							Move the <code class="command">gnome-sc</code> threads to the selected CPU (CPU 0)
						</div></li><li class="listitem"><div class="para">
							Show the result of the move
						</div></li><li class="listitem"><div class="para">
							Reset the CPU list to CPU 1
						</div></li><li class="listitem"><div class="para">
							Move the <code class="command">gnome-sc</code> threads to the selected CPU (CPU 1)
						</div></li><li class="listitem"><div class="para">
							Show the result of the move
						</div></li><li class="listitem"><div class="para">
							Add CPU 0 to the CPU list
						</div></li><li class="listitem"><div class="para">
							Move the <code class="command">gnome-sc</code> threads to the selected CPUs (CPUs 0 and 1)
						</div></li><li class="listitem"><div class="para">
							Show the result of the move
						</div></li></ol></div>

			</div></div></div><br class="example-break" /></div><div class="section" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Saving_Changes"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_the_Command_Line_Interface-Saving_Changes">3.6. Saving Changes</h2></div></div></div><div class="procedure" id="proc-Tuna_User_Guide-Saving_Changes-Saving_Changes_in_the_CLI"><h6>Procedure 3.5. Saving Changes in the CLI</h6><ul><li class="step"><div class="para">
					Use the <code class="command">--save</code> or <code class="command">-s</code> parameter with a descriptive filename to save the current configuration: 
<pre class="screen">
# tuna --save=<em class="replaceable"><code>FILENAME</code></em></pre>

				</div></li></ul></div><div class="important"><div class="admonition_header"><h2>Important</h2></div><div class="admonition"><div class="para">
				This method will not save every option that is able to be changed with Tuna. This will save the kernel thread changes only. Any processes that are not currently running when they are changed will not be saved.
			</div></div></div></div></div><div xml:lang="en-US" class="chapter" id="chap-Tuna_User_Guide-Using_Testing_Tools_with_TUNA" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 4. Using Testing Tools with Tuna</h2></div></div></div><div class="toc"><dl><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_Testing_Tools_with_TUNA-Cyclictest">4.1. Cyclictest</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-Using_Testing_Tools_with_TUNA-Oscilloscope">4.2. Oscilloscope</a></span></dt></dl></div><div class="para">
		Tuna's functionality is enhanced and expanded by the addition of several testing tools. The most important of these is Cyclictest, which is designed specifically to locate and identify latencies in a real-time system. Oscilloscope uses data provided to it and presents it in graph form. By feeding data to the oscilloscope from cyclictest, it graphically displays latencies as they occur.
	</div><div class="para">
		Cyclictest is available in the <code class="filename">rt-tests</code> package. Ensure you are registered with the Red Hat Network, and subscribed to the appropriate MRG Realtime channel. See <a class="xref" href="#chap-Tuna_User_Guide-Installing_TUNA">Chapter 1, <em>Installing Tuna</em></a>. The package can then be installed using the following command: 
<pre class="screen">
# yum install rt-tests
</pre>

	</div><div class="para">
		The oscilloscope is available in the <code class="filename">oscilloscope</code> package. It requires the following dependencies: 
		<div class="itemizedlist"><ul><li class="listitem"><div class="para">
					<code class="filename">pygtk2</code>
				</div></li><li class="listitem"><div class="para">
					<code class="filename">python-matplotlib</code>
				</div></li><li class="listitem"><div class="para">
					<code class="filename">python-numeric</code>
				</div></li></ul></div>
		 
<pre class="screen">
# yum install oscilloscope
</pre>

	</div><div class="section" id="sect-Tuna_User_Guide-Using_Testing_Tools_with_TUNA-Cyclictest"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_Testing_Tools_with_TUNA-Cyclictest">4.1. Cyclictest</h2></div></div></div><div class="para">
			Cyclictest is used to measure the maximum latency of certain events over time. Ideally, the tool would be run over a period of time, under a variety of different stress levels, to determine where the highest latencies lie.
		</div><div class="para">
			Use the <code class="command">--help</code> option to see all the available options: 
<pre class="screen">
# cyclictest --help
cyclictest V 0.66
Usage:
cyclictest &lt;options&gt;

-a [NUM] --affinity        run thread #N on processor #N, if possible
                           with NUM pin all threads to the processor NUM
-b USEC  --breaktrace=USEC send break trace command when latency &gt; USEC
-B       --preemptirqs     both preempt and irqsoff tracing (used with -b)
-c CLOCK --clock=CLOCK     select clock
                           0 = CLOCK_MONOTONIC (default)
                           1 = CLOCK_REALTIME
-C       --context         context switch tracing (used with -b)
-d DIST  --distance=DIST   distance of thread intervals in us default=500
-D       --duration=t      specify a length for the test run
                           default is in seconds, but 'm', 'h', or 'd' maybe added
                           to modify value to minutes, hours or days
-E       --event           event tracing (used with -b)
-f       --ftrace          function trace (when -b is active)
-h       --histogram=US    dump a latency histogram to stdout after the run
                           (with same priority about many threads)
                           US is the max time to be be tracked in microseconds
-i INTV  --interval=INTV   base interval of thread in us default=1000
-I       --irqsoff         Irqsoff tracing (used with -b)
-l LOOPS --loops=LOOPS     number of loops: default=0(endless)
-m       --mlockall        lock current and future memory allocations
-M       --refresh_on_max  delay updating the screen until a new max latency is hit
-n       --nanosleep       use clock_nanosleep
-N       --nsecs           print results in ns instead of us (default us)
-o RED   --oscope=RED      oscilloscope mode, reduce verbose output by RED
-O TOPT  --traceopt=TOPT   trace option
-p PRIO  --prio=PRIO       priority of highest prio thread
-P       --preemptoff      Preempt off tracing (used with -b)
-q       --quiet           print only a summary on exit
-r       --relative        use relative timer instead of absolute
-s       --system          use sys_nanosleep and sys_setitimer
-t       --threads         one thread per available processor
-t [NUM] --threads=NUM     number of threads:
                           without NUM, threads = max_cpus
                           without -t default = 1
-T TRACE --tracer=TRACER   set tracing function
    configured tracers: unavailable (debugfs not mounted)
-u       --unbuffered      force unbuffered output for live processing
-v       --verbose         output values on stdout for statistics
                           format: n:c:v n=tasknum c=count v=value in us
-w       --wakeup          task wakeup tracing (used with -b)
-W       --wakeuprt        rt task wakeup tracing (used with -b)
-y POLI  --policy=POLI     policy of realtime thread (1:FIFO, 2:RR)
                           format: --policy=fifo(default) or --policy=rr
-S       --smp             Standard SMP testing (equals -a -t -n -m -d0)
                           same priority on all threads.
-U       --numa            Standard NUMA testing (similar to SMP option)
                           thread data structures allocated from local node

</pre>

		</div><div class="procedure"><ol class="1"><li class="step"><div class="para">
					Cyclictest must be run as the root user.
				</div></li><li class="step"><div class="para">
					Running cyclictest without any parameters will create one test thread with a 1ms interval: 
<pre class="screen">
# cyclictest
policy: other: loadavg: 0.07 0.19 0.29 3/260 27939          

T: 0 (27939) P: 0 I:1000 C:   3279 Min:   1538 Act:1059544 Avg:881375 Max: 1059876
</pre>

				</div><div class="para">
					The final column displays the maximum latency.
				</div></li><li class="step"><div class="para">
					Use the following command to run one test thread per CPU: 
<pre class="screen">
# cyclictest --smp -p75 -m
policy: fifo: loadavg: 0.01 0.05 0.08 1/338 30074          

T: 0 (30073) P:75 I:1000 C:    821 Min:      6 Act:   39 Avg:   22 Max:      44
T: 1 (30074) P:75 I:1500 C:    542 Min:      7 Act:   64 Avg:   48 Max:      73
</pre>

				</div></li><li class="step"><div class="para">
					Use this command on a NUMA system (an AMD system with more than one memory node): 
<pre class="screen">
# cyclictest --numa -p75 -m
policy: fifo: loadavg: 0.00 0.00 0.00 1/173 25319          

T: 0 (25318) P:75 I:1000 C:   2046 Min:      7 Act:    9 Avg:    8 Max:      12
T: 1 (25319) P:75 I:1500 C:   1363 Min:      8 Act:   10 Avg:    9 Max:      24
</pre>

				</div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-Using_Testing_Tools_with_TUNA-Oscilloscope"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-Using_Testing_Tools_with_TUNA-Oscilloscope">4.2. Oscilloscope</h2></div></div></div><div class="para">
			The oscilloscope uses the data produced by cyclictest and pipes it to a continuously updated graph.
		</div><div class="procedure"><ol class="1"><li class="step"><div class="para">
					Start cyclictest with the <code class="command">-v</code> (verbose) parameter. Then use a <code class="command">|</code> (pipe) to send the output to the oscilloscope: 
<pre class="screen">
# cyclictest -t1 -n -p99 -v | oscilloscope &gt;/dev/null
</pre>

				</div><div class="mediaobject"><img src="images/oscilloscope.png" width="444" alt="Oscilloscope output" /></div></li><li class="step"><div class="para">
					Use the keyboard controls listed in the help section of the oscilloscope to control the output:
				</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
							<span class="keycap"><strong>space</strong></span>: Pause the feed, and display a static graph
						</div></li><li class="listitem"><div class="para">
							<span class="keycap"><strong>s</strong></span>: Create a snapshot of the graph. The image will be saved as a PNG in the current directory.
						</div></li><li class="listitem"><div class="para">
							<span class="keycap"><strong>r</strong></span>: Reset the oscilloscope
						</div></li><li class="listitem"><div class="para">
							<span class="keycap"><strong>q</strong></span>: Quit the program
						</div></li></ul></div></li></ol></div></div></div><div xml:lang="en-US" class="chapter" id="chap-Tuna_User_Guide-Frequently_Asked_Questions" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 5. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><dl><dt>Q: <a href="#id4222210">
					How can I save my configuration for threads other than kernel threads?
				</a></dt><dt>Q: <a href="#id4209955">
					Can Tuna handle multiple sockets and multiple cores?
				</a></dt></dl><div class="qandaset"><div id="id4222210" class="qandaentry"><div class="question"><label>Q:</label><div class="data"><div class="para">
					How can I save my configuration for threads other than kernel threads?
				</div></div></div><div class="answer"><label>A:</label><div class="data"><div class="para">
					The command line interface can be used to add a series of operations to the startup script of any program. Develop the series of commands for Tuna to run at startup, and pass it to the program as a single command. Threads created after the initial command will inherit the affinity and scheduling policy of the thread that creates it. For an example of an appropriate startup script, see <a class="xref" href="#chap-Tuna_User_Guide-Using_the_Command_Line_Interface">Chapter 3, <em>Using the Command Line Interface</em></a>
				</div></div></div></div><div id="id4209955" class="qandaentry"><div class="question"><label>Q:</label><div class="data"><div class="para">
					Can Tuna handle multiple sockets and multiple cores?
				</div></div></div><div class="answer"><label>A:</label><div class="data"><div class="mediaobject"><img src="images/4socket6core.png" width="444" alt="Tuna window for a system with four sockets and six cores" /></div><div class="para">
					Tuna supports multiple sockets and sockets with multiple cores. If there are multiple cores on a socket, they will often share the cache on that socket.
				</div><div class="para">
					The Tuna interface groups multiple sockets within a frame, so that operations can be done on whole sockets or on specific cores.
				</div></div></div></div></div></div></div><div xml:lang="en-US" class="chapter" id="chap-Tuna_User_Guide-More_Information" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 6. More Information</h2></div></div></div><div class="toc"><dl><dt><span class="section"><a href="#sect-Tuna_User_Guide-More_Information-Reporting_Bugs">6.1. Reporting Bugs</a></span></dt><dt><span class="section"><a href="#sect-Tuna_User_Guide-More_Information-Further_Reading">6.2. Further Reading</a></span></dt></dl></div><div class="section" id="sect-Tuna_User_Guide-More_Information-Reporting_Bugs"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-More_Information-Reporting_Bugs">6.1. Reporting Bugs</h2></div></div></div><div class="para">
			If you have determined that the bug is specific to MRG Realtime follow these instructions to enter a bug report:
		</div><div class="procedure"><ol class="1"><li class="step"><div class="para">
					You will need a <a href="https://bugzilla.redhat.com/index.cgi">Bugzilla</a> account. You can create one at <a href="https://bugzilla.redhat.com/createaccount.cgi">Create Bugzilla Account</a>.
				</div></li><li class="step"><div class="para">
					Once you have a Bugzilla account, log in and click on <a href="https://bugzilla.redhat.com/enter_bug.cgi">Enter A New Bug Report</a>.
				</div></li><li class="step"><div class="para">
					You will need to identify the product in which the bug occurs. MRG Realtime appears under Red Hat Enterprise MRG in the Red Hat products list. It is important that you choose the correct product that the bug occurs in.
				</div></li><li class="step"><div class="para">
					Continue to enter the bug information by designating the appropriate component and giving a detailed problem description.
				</div></li></ol></div></div><div class="section" id="sect-Tuna_User_Guide-More_Information-Further_Reading"><div class="titlepage"><div><div><h2 class="title" id="sect-Tuna_User_Guide-More_Information-Further_Reading">6.2. Further Reading</h2></div></div></div><div class="variablelist" id="Further_Reading"><dl><dt class="varlistentry"><span class="term">Red Hat Enterprise MRG and MRG Realtime Product Information</span></dt><dd><div class="para">
						<a href="http://www.redhat.com/mrg">http://www.redhat.com/mrg</a>
					</div></dd><dt class="varlistentry"><span class="term">MRG Realtime and other Red Hat Enterprise MRG manuals</span></dt><dd><div class="para">
						<a href="http://docs.redhat.com/docs/en- US/index.html">http://docs.redhat.com/docs/en- US/index.html</a>
					</div></dd><dt class="varlistentry"><span class="term">Red Hat Knowledgebase</span></dt><dd><div class="para">
						<a href="https://access.redhat.com/knowledge/search">https://access.redhat.com/knowledge/search</a>
					</div></dd></dl></div></div></div><div xml:lang="en-US" class="appendix" id="appe-Tuna_User_Guide-Revision_History" lang="en-US"><div class="titlepage"><div><div><h1 class="title">Revision History</h1></div></div></div><div class="para">
		<div class="revhistory"><table border="0" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="3"><strong>Revision History</strong></th></tr><tr><td align="left">Revision 1-1</td><td align="left">Thu Sep 22 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Version numbering change</td></tr></table>

				</td></tr><tr><td align="left">Revision 1-0</td><td align="left">Thu Jun 23 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Prepared for publishing</td></tr></table>

				</td></tr><tr><td align="left">Revision 0.1-1</td><td align="left">Wed Feb 23 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Minor XML updates</td></tr></table>

				</td></tr><tr><td align="left">Revision 0.1-0</td><td align="left">Wed Feb 23 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Fork from 1.3</td></tr></table>

				</td></tr></table></div>

	</div></div></div></body></html>
